Public Class frmImage

    Private Sub picPreview_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picPreview.MouseDown

        Dim XX As Double, YY As Double

        ' Use the selected fractal
        With frmMain.SelectedFractal.ClassInstance

            ' Calculate the real position
            XX = ((.ZoomWidth / picPreview.Width) * e.X) + .ZoomLeft
            YY = ((.ZoomHeight / picPreview.Height) * e.Y) + .ZoomTop

            ' Modify zoom-settings
            Select Case e.Button
                Case Windows.Forms.MouseButtons.Left ' Zoom in
                    .ZoomWidth *= My.Settings.ZoomFactor
                    .ZoomHeight *= My.Settings.ZoomFactor
                Case Windows.Forms.MouseButtons.Right  ' Zoom out
                    .ZoomWidth /= My.Settings.ZoomFactor
                    .ZoomHeight /= My.Settings.ZoomFactor
            End Select

            ' Relocate
            .ZoomLeft = XX - (.ZoomWidth / 2)
            .ZoomTop = YY - (.ZoomHeight / 2)

            ' Update the properties
            frmProperties.dataProperties.Refresh()

        End With

        ' Regenerate this image
        frmMain.GenerateImage(Me, True)

    End Sub

    Private Sub picPreview_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles picPreview.MouseLeave

        ' Clear the statusbar
        frmMain.SetStatusBar(0, 0, 0)

    End Sub

    Private Sub picPreview_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picPreview.MouseMove

        ' Use the selected fractal
        With frmMain.SelectedFractal.ClassInstance

            Dim XX As Double, YY As Double
            Dim zoomX As Single = .ZoomLeft
            Dim zoomY As Single = .ZoomTop
            Dim zoomWidth As Single = .ZoomWidth
            Dim zoomHeight As Single = .ZoomHeight

            ' Calculate the real position
            XX = ((zoomWidth / picPreview.Width) * e.X) + zoomX
            YY = ((zoomHeight / picPreview.Height) * e.Y) + zoomY

            ' Set the values
            frmMain.SetStatusBar(XX, YY, ((((zoomWidth / 2) + zoomX) - XX) ^ 2 + (((zoomHeight / 2) + zoomY) - YY) ^ 2) ^ 0.5)

        End With

    End Sub

End Class