Imports System.Windows.Forms
Imports System.Runtime.InteropServices
Imports System.Math

Public Class frmMain
#Region "Trivial"
    Private IgnoreClose As Integer

    Private Sub mnuExit_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mnuExit.Click
        Me.Close()
    End Sub

    Private Sub mnuViewToolbar_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mnuViewToolbar.Click
        My.Settings.ViewToolbar = Me.mnuViewToolbar.Checked
        ToolStrip.Visible = mnuViewToolbar.Checked
    End Sub

    Private Sub mnuViewStatusbar_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mnuViewStatusbar.Click
        My.Settings.ViewStatusbar = Me.mnuViewToolbar.Checked
        StatusStrip.Visible = mnuViewStatusbar.Checked
    End Sub

    Private Sub mnuProperties_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuProperties.Click
        If Not mnuProperties.Checked Then
            frmProperties.Show()
        Else
            frmProperties.Hide()
        End If
    End Sub

    Private Sub mnuNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNew.Click
        NewImage()
    End Sub

    Private Sub mnuOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOpen.Click
        OpenFile()
    End Sub

    Private Sub toolNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolNew.Click
        NewImage()
    End Sub

    Private Sub toolOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolOpen.Click
        OpenFile()
    End Sub

    Private Sub toolSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolSave.Click
        SaveFile()
    End Sub

    Private Sub mnuSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSave.Click
        SaveFile()
    End Sub

    Private Sub mnuSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuSaveAs.Click
        SaveFile(True)
    End Sub

    Private Sub toolEdit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolEdit.Click
        EditCode()
    End Sub

    Private Sub mnuEditImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuEditImage.Click
        EditCode()
    End Sub

    Private Sub toolGenerate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles toolGenerate.Click
        GenerateImage(frmImage)
    End Sub

    Private Sub mnuGenerateImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuGenerateImage.Click
        GenerateImage(frmImage)
    End Sub

    Private Sub cmdCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCopy.Click
        mnuCopy_Click(sender, e)
    End Sub

    Private Sub mnuOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOptions.Click
        ShowOptions(New frmSettings)
    End Sub

    Private Sub mnuCascade_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mnuCascade.Click
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub

    Private Sub mnuTileVertical_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mnuTileVertical.Click
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub

    Private Sub mnuTileHorizontal_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mnuTileHorizontal.Click
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub

    Private Sub mnuArrangeIcons_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mnuArrangeIcons.Click
        Me.LayoutMdi(MdiLayout.ArrangeIcons)
    End Sub

    Private Sub mnuCloseAll_Click(ByVal sender As Object, ByVal e As EventArgs) Handles mnuCloseAll.Click
        CloseAll()
    End Sub

    Private Sub cmdImportObject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdImportObject.Click
        mnuImportObject_Click(sender, e)
    End Sub

    Private Sub cmdRemoveObject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRemoveObject.Click
        mnuRemoveObject_Click(sender, e)
    End Sub

    Private Sub cmdNewObject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdNewObject.Click
        mnuNewObject_Click(sender, e)
    End Sub

    Private Sub cmdOptions_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOptions.Click
        mnuOptions_Click(sender, e)
    End Sub
#End Region

    ' The code base that'll generate the image for us
    Public Fractals As List(Of VBCode)

    ' The path to the last opened file
    Public FilePath As String

    ' Libraries to use
    Private aLibraries As String() = {"System", "System.Drawing", "System.Drawing.Imaging", _
     "System.Math", "Microsoft.VisualBasic.Information", "Microsoft.VisualBasic.Interaction"}

    Private Sub frmMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        ' Close the form
        Select Case IgnoreClose
            Case 0

                ' Allows the properties form to be closed
                frmProperties.AllowClose = True
                frmProperties.Close()
                frmImage.Close()

                ' First, avoid this specific part to be recalled, and call this function agan-
                IgnoreClose = 1
                Me.Close()

            Case 1
                IgnoreClose = 2
                Me.Close()
        End Select
    End Sub

    Public Sub CloseAll()

        ' Close all child forms of the parent.
        For Each ChildForm As Form In Me.MdiChildren
            ChildForm.Close()
        Next

    End Sub

    Public Sub UpdateProperties(ByVal Dialog As frmProperties)

        ' Initialize this list
        Dialog.DataObjects = Fractals
        Dialog.UpdateList()
        Dialog.UpdateRows()

        ' Show the form
        Dialog.Show()

    End Sub

    Public ReadOnly Property SelectedFractal() As VBCode
        Get
            Return Fractals(frmProperties.lstObjects.SelectedIndex)
        End Get
    End Property

    ' Used to initialize the picture to use
    Public Sub SetImage(ByVal Source As frmImage, ByVal Image As Drawing.Bitmap)

        With Source.picPreview

            ' Remove the image
            If Not (.Image Is Nothing) Then
                .Image.Dispose()
            End If

            ' Show and set the image
            .Visible = True
            .Image = Image

        End With

    End Sub

    Private Function OpenFractals(ByVal File As IO.FileStream) As Boolean

        Dim Compress As IO.Compression.GZipStream, Reader As IO.BinaryReader, oValue As Object
        Dim Tell As Integer, Amount As Integer, oFractal As VBCode, oField As Reflection.FieldInfo

        Try

            ' This file is compress. Uncompress it whilst opening.
            Compress = New IO.Compression.GZipStream(File, IO.Compression.CompressionMode.Decompress)
            Reader = New IO.BinaryReader(Compress)

            ' Assume things are ok
            OpenFractals = True

            ' Retrieve the amount of fractals
            Amount = Reader.ReadInt32

            ' Read the content for each fractal
            For Tell = 1 To Amount

                ' Compile the fractal
                OpenFractals = OpenFractals And CreateClass(Reader.ReadString)

                ' Get the fractal we just made
                oFractal = Fractals(Fractals.Count - 1)

                ' Set the filters
                oFractal.FilterProcess = Reader.ReadString
                oFractal.FilterProcessEnd = Reader.ReadString
                oFractal.FilterSetPixel = Reader.ReadString
                oFractal.FilterEndPixel = Reader.ReadString

                ' Read the data that is saved
                If OpenFractals Then
                    For Each oField In oFractal.ClassInstance.GetType.GetFields

                        ' Read the field depending on its type
                        Select Case oField.FieldType.Name
                            Case "Decimal" : oValue = Reader.ReadDecimal()
                            Case "Boolean" : oValue = Reader.ReadBoolean()
                            Case "Double" : oValue = Reader.ReadDouble()
                            Case "Single" : oValue = Reader.ReadSingle()
                            Case "Long", "Int64" : oValue = Reader.ReadInt64()
                            Case "Integer", "Int32" : oValue = Reader.ReadInt32()
                            Case "Short", "Int16" : oValue = Reader.ReadInt16
                            Case "Byte" : oValue = Reader.ReadByte()
                            Case Else : oValue = Reader.ReadString()
                        End Select

                        ' Set the read field to the object
                        oField.SetValue(oFractal.ClassInstance, oValue)

                    Next
                End If

            Next

        Catch ex As Exception

            ' Error - return false.
            OpenFractals = False

        Finally

            ' Close the file stream
            Reader.Close()

        End Try



    End Function

    Public Sub OpenFile(Optional ByVal ResetList As Boolean = True)

        Dim Text As IO.StreamReader, bCompiled As Boolean

        ' Firstly, retrieve what file to open
        If OpenFileDialog.ShowDialog = Windows.Forms.DialogResult.OK Then

            Try

                ' Open the given file
                Dim File As New IO.FileStream(OpenFileDialog.FileName, IO.FileMode.Open)

                ' Reset the list, if set to
                If ResetList Then

                    ' Close all previous classes
                    CloseAll()

                    ' Creates a new fractal-list
                    Fractals = New List(Of VBCode)

                End If

                Select Case IO.Path.GetExtension(OpenFileDialog.FileName)
                    Case ".frc"

                        ' Open the file as an array of fractals
                        bCompiled = OpenFractals(File)

                    Case Else

                        ' Just open the file as a text file.
                        Text = New IO.StreamReader(File)

                        ' Add the code to the list
                        bCompiled = CreateClass(Text.ReadToEnd)

                End Select

                ' Compiles this new code
                If bCompiled Then

                    ' Save this file path
                    FilePath = OpenFileDialog.FileName

                    ' Render the image automatically
                    If My.Settings.GenWhenOpening Then
                        GenerateImage(frmImage)
                        frmImage.ClientSize = New Size(My.Settings.Width, _
                         My.Settings.Height)
                    End If

                End If

            Catch ex As Exception

                ' Show the error to the user
                MessageBox.Show("Cannot open file:" & Environment.NewLine & _
                 ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

            Finally

                If Not (Text Is Nothing) Then
                    Text.Dispose()
                End If

            End Try

        End If

    End Sub

    Public Sub SaveFile(Optional ByVal newFile As Boolean = False)

        Dim sFile As String, Writer As IO.BinaryWriter, Text As IO.StreamWriter, Fractal As VBCode
        Dim oField As Reflection.FieldInfo

        ' If the user hasn't opened a file, or we're instructed to make a new file, ...
        If newFile Or (FilePath.Length = 0) Then

            ' Get a file path from the filer
            If SaveFileDialog.ShowDialog = Windows.Forms.DialogResult.OK Then
                ' Save it
                sFile = SaveFileDialog.FileName
            Else
                ' The user has cancelled - exit.
                Exit Sub
            End If

        Else

            ' Use the saved file path
            sFile = FilePath

        End If

        ' Attempt to save this file
        Try

            ' Create the file
            Dim File As New IO.FileStream(sFile, IO.FileMode.Create)

            Select Case IO.Path.GetExtension(sFile)
                Case ".frc"

                    Dim Compress As IO.Compression.GZipStream

                    ' These files are compress - thus, compress the data whilst saving.
                    Compress = New IO.Compression.GZipStream(File, IO.Compression.CompressionMode.Compress)
                    Writer = New IO.BinaryWriter(Compress)

                    ' Save the total amount of fractals
                    Writer.Write(Fractals.Count)

                    ' Go through each fractal, ...
                    For Each Fractal In Fractals

                        ' ... saving its code ...
                        Writer.Write(Fractal.ClassCode)

                        ' ... its filters ...
                        Writer.Write(Fractal.FilterProcess)
                        Writer.Write(Fractal.FilterProcessEnd)
                        Writer.Write(Fractal.FilterSetPixel)
                        Writer.Write(Fractal.FilterEndPixel)

                        ' ... and all its properties.
                        For Each oField In Fractal.ClassInstance.GetType.GetFields
                            Writer.Write(oField.GetValue(Fractal.ClassInstance))
                        Next

                    Next

                Case Else

                    ' Just save as a normal text file
                    Text = New IO.StreamWriter(File)

                    ' Write the data
                    Text.Write(frmProperties.SelectedItem.ClassCode)

            End Select

            ' Save this file path
            FilePath = sFile

        Catch ex As Exception

            ' Inform the user
            MessageBox.Show("Cannot save file:" & Environment.NewLine & _
             ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        Finally

            ' Close the file
            If Not (Writer Is Nothing) Then
                Writer.Close()
            End If

            If Not (Text Is Nothing) Then
                Text.Dispose()
            End If

        End Try

    End Sub

    Public Function InsertFilters(ByVal Code As String, ByVal Fractal As VBCode) As String

        ' Replace the areas in question
        Code = Replace(Code, "'Pixel-start'", Fractal.FilterProcess)
        Code = Replace(Code, "'Pixel-end'", Fractal.FilterProcessEnd)
        Code = Replace(Code, "'Assign-set'", Fractal.FilterSetPixel)
        Code = Replace(Code, "'Assign-end'", Fractal.FilterEndPixel)

        ' Returned the modified code
        Return Code

    End Function

    Public Function CreateClass(ByVal Code As String) As Boolean

        Try

            ' Create a new class
            Dim VBCode As New VBCode(aLibraries, InsertFilters(Code, New VBCode))

            ' Save the code we compiled
            VBCode.ClassCode = Code

            ' Append this to the list
            Fractals.Add(VBCode)

            ' Make the properties-form a child of this form
            frmProperties.MdiParent = Me

            ' Update properties
            UpdateProperties(frmProperties)

            ' Everything went ok
            Return True

        Catch ex As Exception

            ' Inform the user
            MessageBox.Show("Cannot compile:" & Environment.NewLine & _
             ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try

    End Function

    Public Function EditClass(ByVal refCode As VBCode, ByVal Code As String) As Boolean

        Try

            ' Save the code we want to compile
            refCode.ClassCode = Code

            ' Recompile the class
            refCode.Compile(InsertFilters(Code, refCode))

            ' Update properties
            UpdateProperties(frmProperties)

            ' Everything went ok
            Return True

        Catch ex As Exception

            ' Inform the user
            MessageBox.Show("Cannot compile:" & Environment.NewLine & _
             ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try

    End Function

    Public Sub EditCode()

        Dim oDialog As New frmEdit(frmProperties.SelectedItem.ClassCode)

        ' Show the dialog
        If oDialog.ShowDialog = Windows.Forms.DialogResult.OK Then

            ' Recompile the code
            EditClass(frmProperties.SelectedItem, oDialog.txtCode.Text)

        End If

    End Sub

    Public Sub NewImage()

        ' Clear variable
        FilePath = ""

        ' Reset all
        CloseAll()

        ' Create a new list of fractals
        Fractals = New List(Of VBCode)

        ' Use a default code
        CreateClass(My.Resources.DefaultCode)

    End Sub

    Public Sub GenerateImage(ByVal Source As frmImage, Optional ByVal IgnoreDialog As Boolean = False)

        Dim iTick As Integer, Fractal As VBCode

        ' Retrieve the settings
        If My.Settings.AutoAsk And (Not IgnoreDialog) Then
            ' Let the user choose how to generate the image
            If Not ShowOptions(New frmSettings) Then
                Exit Sub
            End If
        End If

        ' Show the source
        Source.Show()
        Source.MdiParent = Me

        ' Save the current time
        iTick = Environment.TickCount

        ' Create the bitmap to use
        Dim iWidth As Integer = My.Settings.Width, oData As Imaging.BitmapData
        Dim iHeight As Integer = My.Settings.Height
        Dim aBitmap(0) As Integer
        Dim oBitmap As New Bitmap(iWidth, iHeight, Imaging.PixelFormat.Format32bppRgb)

        ' Lock the area we're interested in
        oData = oBitmap.LockBits(New Rectangle(0, 0, iWidth, iHeight), _
         Imaging.ImageLockMode.ReadOnly, oBitmap.PixelFormat)

        Try

            ' Allocate the array
            ReDim aBitmap((oData.Stride / 4) * oData.Height)

            ' Let the code generate the pixel array
            For Each Fractal In Fractals
                If Fractal.ClassInstance.Visible Then
                    Fractal.Run("Fractal", oBitmap.Size, aBitmap)
                End If
            Next

            ' Copy the given array to the bitmap
            Marshal.Copy(aBitmap, 0, oData.Scan0, aBitmap.Length - 1)

            ' Unlock and copy the bitmap
            oBitmap.UnlockBits(oData)
            SetImage(Source, oBitmap)

            ' Save the time it took to generate the image
            lblGeneration.Text = "Time: " & Environment.TickCount - iTick & " ms"

        Catch ex As Exception

            Dim sMessage As String

            ' "Clean up"
            oBitmap.UnlockBits(oData)
            oBitmap.Dispose()

            ' Retrieve the exception text to use
            If ex.InnerException Is Nothing Then
                sMessage = ex.Message
            Else
                sMessage = ex.InnerException.Message
            End If

            ' Inform the user if something went wrong
            MessageBox.Show("Cannot generate image:" & Environment.NewLine & _
             sMessage, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

        End Try

        ' Clear the array
        Erase aBitmap

    End Sub

    Public Function ShowOptions(ByVal Dialog As frmSettings) As Boolean

        ' Set the settings
        With Dialog
            .txtWidth.Text = My.Settings.Width
            .txtHeight.Text = My.Settings.Height
            .txtZoomFactor.Text = My.Settings.ZoomFactor
            .chkAutoAsk.Checked = My.Settings.AutoAsk
        End With

        ' If the dialog returned YES ...
        If Dialog.ShowDialog = Windows.Forms.DialogResult.OK Then

            ' ... save the changes.
            With Dialog
                My.Settings.Width = .txtWidth.Text
                My.Settings.Height = .txtHeight.Text
                My.Settings.ZoomFactor = .txtZoomFactor.Text
                My.Settings.AutoAsk = .chkAutoAsk.Checked
            End With

            ' The user pressed OK
            Return True

        End If

    End Function

    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' Set the icon
        Me.Icon = My.Resources.Mandelbrot

        ' Copy the tooltips
        cmdCopy.ToolTipText = mnuCopy.ToolTipText
        cmdImportObject.ToolTipText = mnuImportObject.ToolTipText
        cmdRemoveObject.ToolTipText = mnuRemoveObject.ToolTipText
        cmdNewObject.ToolTipText = mnuNewObject.ToolTipText

        ' Update current visibility
        StatusStrip.Visible = My.Settings.ViewStatusbar
        ToolStrip.Visible = My.Settings.ViewToolbar

        ' Initialize dialogs
        OpenFileDialog.InitialDirectory = IO.Path.Combine(IO.Path.GetDirectoryName(Application.ExecutablePath), "Images")
        SaveFileDialog.InitialDirectory = OpenFileDialog.InitialDirectory

        ' Use a new image
        NewImage()

    End Sub

    Public Sub SetStatusBar(ByVal X As Single, ByVal Y As Single, ByVal D As Single)

        ' Set the statusbar-elements
        lblPositionX.Text = "X: " & X
        lblPositionY.Text = "Y: " & Y
        lblPositionD.Text = "D: " & D

    End Sub

    Private Sub mnuAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAbout.Click

        ' Show the author
        MessageBox.Show("Made by Kristian S. Stangeland (kr_stang@hotmail.com)", "Author", MessageBoxButtons.OK, MessageBoxIcon.Information)

    End Sub

    Private Sub mnuCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuCopy.Click

        ' Copy the current image to the clipboard
        Clipboard.Clear()
        Clipboard.SetData(DataFormats.Bitmap, frmImage.picPreview.Image)

    End Sub

    Private Sub mnuRemoveObject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuRemoveObject.Click

        ' Remove the current selected object
        Fractals.RemoveAt(frmProperties.lstObjects.SelectedIndex)

        ' Update the list
        UpdateProperties(frmProperties)

    End Sub

    Private Sub mnuImportObject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuImportObject.Click

        ' Open a file without removing the other fractals
        OpenFile(False)

    End Sub

    Private Sub mnuNewObject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuNewObject.Click

        ' Create a new, default fractal.
        CreateClass(My.Resources.DefaultCode)

        ' Update the properties
        UpdateProperties(frmProperties)

    End Sub

    Private Sub mnuShowLicence_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuShowLicence.Click

        Dim oGPL As IO.FileStream, oText As IO.StreamReader, oDialog As frmEdit

        Try

            ' Open the GPL file
            oGPL = New IO.FileStream(IO.Path.Combine(IO.Path.GetDirectoryName( _
             Application.ExecutablePath), "Readme.txt"), IO.FileMode.Open)
            oText = New IO.StreamReader(oGPL)

            ' Retrieve and set the GPL text
            oDialog = New frmEdit(oText.ReadToEnd)
            oDialog.Text = "Licence"

            ' Make the textbox uneditable and hide the 
            oDialog.txtCode.ReadOnly = True
            oDialog.ShowDialog()

        Catch ex As Exception
            MessageBox.Show("Error opening licence: " & System.Environment.NewLine & _
             ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally

            ' Close the stream
            If Not (oText Is Nothing) Then
                oText.Close()
            End If

            ' Close the form
            If Not (oDialog Is Nothing) Then
                oDialog.Close()
            End If

        End Try

    End Sub

    Public Sub SaveImage(ByVal Image As Bitmap)

        Dim oFormat As Imaging.ImageFormat

        ' Get a file path from the filer
        If SaveImageDialog.ShowDialog = Windows.Forms.DialogResult.OK Then

            Try

                ' Retrieve the correct format
                Select Case IO.Path.GetExtension(SaveImageDialog.FileName).ToLower
                    Case ".bmp"
                        oFormat = Imaging.ImageFormat.Bmp
                    Case ".gif"
                        oFormat = Imaging.ImageFormat.Gif
                    Case ".ico"
                        oFormat = Imaging.ImageFormat.Icon
                    Case ".png"
                        oFormat = Imaging.ImageFormat.Png
                    Case ".jpg", ".jpeg"
                        oFormat = Imaging.ImageFormat.Jpeg
                    Case ".tif", ".tiff"
                        oFormat = Imaging.ImageFormat.Tiff
                    Case Else
                        Throw New Exception("Image format not recognized.")
                End Select

                ' Save the image using the given format
                Image.Save(SaveImageDialog.FileName, oFormat)

            Catch ex As Exception
                MessageBox.Show("Cannot save image: " & ex.Message, "Error", _
                 MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try

        End If

    End Sub

    Private Sub mnuExportImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExportImage.Click

        ' Save the current image (if there is anything to save
        If frmImage.picPreview.Image Is Nothing Then
            MessageBox.Show("Error: Image is empty. Cannot save.", "Error", _
             MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            SaveImage(frmImage.picPreview.Image)
        End If

    End Sub
End Class